typedef signed char       schar;
typedef unsigned char     uchar;
typedef signed short      sshort;

#include "TRAMI_Standard_AT_Strategy_v230.c"

double OLD_T = -1.0;

void TCU_IF(
//output
	double *DBL_trans_gear,						// 1
	double *DBL_trans_gear_ratio,				// 2
	double DBL_tau_clutch_cap[_MaxCL],			// 3
	double DBL_f_synchro_n[_MaxSyn],			// 4
	double *DBL_tau_k0_clutch_cap,				// 5
	double *DBL_tau_p2m_target,					// 6
	double *DBL_p_line_pa,						// 7
	double *DBL_p_pulley_pri_pa,				// 8
	double *DBL_p_pulley_sec_pa,				// 9
	double *DBL_i_actuator_ampere,				// 10
	double *DBL_i_eop_ampere,					// 11
	double *DBL_qv_cooler_trans_fluid_m3ps,		// 12
	double *DBL_qv_cooler_eng_water_m3ps,		// 13
	double *DBL_torque_gain_drivetrain,				// 14
	double *DBL_flag_shift	,					// 15
	double *DBL_tau_engine_max_req,				// 16
	double *DBL_tau_engine_min_req,				// 17
	double *DBL_w_engine_target_radps,			// 18
	double *DBL_tau_trans_input,				// 19
	double *DBL_flag_trans_lockup,				// 20
//Input
	double DBL_flag_initialize,
	double DBL_w_starting_device_input_radps,
	double DBL_w_gearbox_input_radps,
	double DBL_w_gearbox_output_radps,
	const double DBL_w_synchoro_dif_radps[_MaxSyn],
	double DBL_t_trans_fluid_k,
	double DBL_t_engine_water_k,
	double DBL_v_vehicle_mps,
	double DBL_tau_brake,	
	double DBL_accel_position_per,
	double DBL_trans_shifter_position,
	double DBL_w_engine_radps,
	double DBL_w_engine_idle_radps,
	double DBL_tau_engine_target,
	double DBL_tau_engine,
	double DBL_tau_engine_min_pos,
	double DBL_tau_engine_max_pos,
	double DBL_tau_p2m_req,
	double DBL_flag_k0_clutch_open,
	double DBL_drive_mode,
// output for observation
	double DBL_obs_tcu[10],
// Multiple call check
	double DBL_T
)
{
	int i;
	
	if( OLD_T == DBL_T ) goto exit1;
	OLD_T = DBL_T;
	
	//outp[Jϐ
static float F_trans_gear;
static float F_trans_gear_ratio;
static float Buf_tau_clutch_cap[_MaxCL];// 1.  eNb`̃gNe			[Nm]
static float Buf_f_synchro_n[_MaxSyn];// 2.  VN̑[N]
static float F_tau_k0_clutch_cap;
static float F_tau_p2m_target;
static float F_p_line_pa;
static float F_p_pulley_pri_pa;
static float F_p_pulley_sec_pa;
static float F_i_actuator_ampere;
static float F_i_eop_ampere;
static float F_qv_cooler_trans_fluid_m3ps;
static float F_qv_cooler_eng_water_m3ps;
static float F_torque_gain_drivetrain;
static schar C_flag_shift;
static float F_tau_engine_max_req;
static float F_tau_engine_min_req;
static float F_w_engine_target_radps;
static float F_tau_trans_input;
static schar C_flag_trans_lockup;
	
static float Buf_obs_tcu[10];

//Inputp[Jϐ
static float Buf_w_synchoro_dif_radps[_MaxSyn];

////////////////////////////////////////////////////////////////////
	for( i=0; i<10; i++ )
	{
		Buf_w_synchoro_dif_radps[ i ] = (float)DBL_w_synchoro_dif_radps[ i ];
	}
////////////////////////////////////////////////////////////////////

	
//*****************************************************
	//TRAMIC\[Xɓ
 TCU_Main(
	 //Output
	&F_trans_gear,
	&F_trans_gear_ratio,
	&Buf_tau_clutch_cap[ 0 ],
	&Buf_f_synchro_n[ 0 ],
	&F_tau_k0_clutch_cap,
	&F_tau_p2m_target,
	&F_p_line_pa,
	&F_p_pulley_pri_pa,
	&F_p_pulley_sec_pa,
	&F_i_actuator_ampere,
	&F_i_eop_ampere,
	&F_qv_cooler_trans_fluid_m3ps,
	&F_qv_cooler_eng_water_m3ps,
	&F_torque_gain_drivetrain,
	&C_flag_shift,
	&F_tau_engine_max_req,
	&F_tau_engine_min_req,
	&F_w_engine_target_radps,
	&F_tau_trans_input,
	&C_flag_trans_lockup,
      //Input
	(schar)DBL_flag_initialize,
	(float)DBL_w_starting_device_input_radps,
	(float)DBL_w_gearbox_input_radps,
	(float)DBL_w_gearbox_output_radps,
		   Buf_w_synchoro_dif_radps,
	(float)DBL_t_trans_fluid_k,
	(float)DBL_t_engine_water_k,
	(float)DBL_v_vehicle_mps,
	(float)DBL_tau_brake,	
	(float)DBL_accel_position_per,
	(float)DBL_trans_shifter_position,
	(float)DBL_w_engine_radps,
	(float)DBL_w_engine_idle_radps,
	(float)DBL_tau_engine_target,
	(float)DBL_tau_engine,
	(float)DBL_tau_engine_min_pos,
	(float)DBL_tau_engine_max_pos,
	(float)DBL_tau_p2m_req,
	(float)DBL_flag_k0_clutch_open,
	(float)DBL_drive_mode,
 		   Buf_obs_tcu
);

exit1:;
//*****************************************************	
//double^֌^ϊsAOutput֓n
	*DBL_trans_gear					= F_trans_gear;
	*DBL_trans_gear_ratio			= F_trans_gear_ratio;
	for( i=0; i<_MaxCL; i++ )
	{
		DBL_tau_clutch_cap[ i ]		= Buf_tau_clutch_cap[ i ];
	}
	for( i=0; i<_MaxSyn; i++ )
	{		
		DBL_f_synchro_n[ i ]		= Buf_f_synchro_n[ i ];
	}
	*DBL_tau_k0_clutch_cap			= F_tau_k0_clutch_cap;
	*DBL_tau_p2m_target				= F_tau_p2m_target;
	*DBL_p_line_pa					= F_p_line_pa;
	*DBL_p_pulley_pri_pa			= F_p_pulley_pri_pa;
	*DBL_p_pulley_sec_pa			= F_p_pulley_sec_pa;
	*DBL_i_actuator_ampere			= F_i_actuator_ampere;
	*DBL_i_eop_ampere				= F_i_eop_ampere;
	*DBL_qv_cooler_trans_fluid_m3ps	= F_qv_cooler_trans_fluid_m3ps;
	*DBL_qv_cooler_eng_water_m3ps	= F_qv_cooler_eng_water_m3ps;
	*DBL_torque_gain_drivetrain		= F_torque_gain_drivetrain;
	*DBL_flag_shift					= C_flag_shift;
	*DBL_tau_engine_max_req			= F_tau_engine_max_req;
	*DBL_tau_engine_min_req			= F_tau_engine_min_req;
	*DBL_w_engine_target_radps		= F_w_engine_target_radps;
	*DBL_tau_trans_input			= F_tau_trans_input;
	*DBL_flag_trans_lockup			= C_flag_trans_lockup;
	
	for( i=0; i<10; i++ )
	{
		DBL_obs_tcu[ i ]			= Buf_obs_tcu[ i ];
	}
}
#undef	_MaxCL					//őNb`
#undef	_MaxSyn					//őVN
#undef    CONST_CL_NUM         // Nb`̐
#undef    CONST_SYN_NUM        // VN̐
